﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Threading.Tasks.Dataflow;

namespace ConsoleApplication1
{
    class Program
    {
        static BatchBlock<string> pubSub = new BatchBlock<string>(3);
        static int counter = 0;

        static async void Process()
        {
            while (true)
            {
                var messages = await pubSub.ReceiveAsync();
                foreach (var item in messages)
                {
                    counter++;
                    Console.WriteLine("Got message number {0}: {1}", counter, item);
                }
            }
        }

        static void Main(string[] args)
        {            
            Process();

            for (int i = 0; i < 20; i++)
            {
                Task.Factory.StartNew(() =>
                {
                    Thread.Sleep(new Random().Next(200, 1000));
                    pubSub.Post(DateTime.Now.ToLongTimeString());
                });
            }

            Console.ReadLine();
        }
    }
}
